/*
 *  Name        : kjoy.h
 *  Version     : 0.4
 *  Description : Joystick setup utility for KDE
 *
 *  Copyright (C) 1998 Luca Montecchiani <m.luca@usa.net>       
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef main_included
#define main_included

#include <qtimer.h>
#include <qcombo.h>
#include <qtabdlg.h>
#include <qpainter.h>
#include <qmsgbox.h>
#include <qwidget.h>
#include <qdatetm.h>
#include <qpixmap.h>
#include <qlabel.h>
#include <qlined.h>
#include <qpushbt.h>
#include <qchkbox.h>
#include <qlabel.h>

#include <kapp.h> 
#include <klocale.h>
#include <kslider.h>
#include <ktablistbox.h>
#include <kcontrol.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>   
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>      
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "joy_drv/joystick.h"

#ifdef kjoy_included
#undef kjoy_included
/* XPM */
#include "xpm/kjoy.xpm"
#include "xpm/kjoy2.xpm"
#endif

#define VER	4
#define ktr klocale->translate  

class Kjoy : public KConfigWidget
{
Q_OBJECT
public:
	Kjoy::Kjoy(QWidget *parent=0, const char *name=0, bool init=FALSE );
	~Kjoy();

	void		applySettings();
	void		loadSettings();    
	void		Init();    

protected:
	void		paintEvent( QPaintEvent * );

private slots:
	void		Timeout();
	void		About();
	void		help();
	void		Insmod();
	void 		Set();
	bool 		Get();
	void 		ChangeDevice(int i);
	void 		Error(QString msg);
	void 		LoadDevices();
	void 		CleanupVar(bool HARD);
	void		rchange(int i);
	void		xchange(int i);
	void		ychange(int i);

private:
	struct JS_DATA_TYPE jsdata; 
	struct JS_DATA_TYPE js_cal[2]; 
	QString		Buf;
	QString		Pinsmod;
	int		ver;
	int		res;
	int		tml[2];
	int		tmo[2];
	int		js[2];
	int		oldx;
	int		oldy;
	int		maxx;
	int		minx;
	int		maxy;
	int		miny;
	float		deltax;
	float		deltay;
	int		Curr_js;
	bool		Busy;
	bool		Autoload;
	QComboBox* 	Devices;
	QFrame* 	Display;
	QFrame*		But1;
	QFrame* 	But2;
	QFrame* 	But3;
	QFrame* 	But4;
	QSlider* 	xslider;
	QSlider* 	yslider;
	QSlider* 	rslider;             
	QLabel*		xrange;
	QLabel*		yrange;
	QLabel*		icona1;
	QLabel*		icona2;
	QLabel*		Status;
	QCheckBox*	Ck_Autoload;
};

#endif // main_included                        
